/**
 * ACM ICPC Finals 2006, problem E (Bit Compressor).
 * @author Marcin Balcerzak
 * (translated to Java program in C++; comments by Karolina Soltys)
 */

import java.util.*;
import java.io.*;

public class BitCompressor1 {
	static public int L;
	static public int N;
	static public int sections;
	static public int global_value;
	static public int result;
	static public int casenumber;

	static public class Interval{
		public int value;
		public int zeros;
		public int temp_value;
		public Interval() { value=0; zeros=0; temp_value=0; }
	}

	static public Interval[] section=new Interval[40];

	static public void check(int section_nr, int zeros_res){
		if (section_nr<sections-1){	
		/* we're not in the final section yet */
		if (section[section_nr].zeros<=zeros_res) {
			/* zeros_res exceeds the number of 0's in the section, so it is glued with the following section, what consumes some of the 0's in the zeros_res variable */
			section[section_nr+1].temp_value=section[section_nr].temp_value * (int) Math.pow(2,section[section_nr].zeros+(int) (Math.log(section[section_nr+1].value)/Math.log(2))+1) + section[section_nr+1].value;
			check(section_nr+1, zeros_res - section[section_nr].zeros);
		}
		/* in this loop the program checks all possibilities of using some number (or none) of 0's in this section, and transfers right the rest of the 0's */
		for (int i=Math.min(section[section_nr].zeros - 1, zeros_res) ; i>=2; i--) {
			global_value+=section[section_nr].temp_value * (int) Math.pow(2, i);	
			check(section_nr+1, zeros_res - i);
			global_value-=section[section_nr].temp_value * (int) Math.pow(2, i);
		}
		/* below the program deals with a special case of a sequence 10 that cannot be decoded as 11 */
		if ((section[section_nr].temp_value!=1)&&(zeros_res>=1)&&(section[section_nr].zeros > 1)){
		 	global_value+=section[section_nr].temp_value * (int) Math.pow(2, 1);	
			check(section_nr+1, zeros_res - 1);
			global_value-=section[section_nr].temp_value * (int) Math.pow(2, 1);
		}  
        global_value+=section[section_nr].temp_value * (int) Math.pow(2, 0);	
		check(section_nr+1, zeros_res);
		global_value-=section[section_nr].temp_value * (int) Math.pow(2, 0);
		/* another special case of a sequence of two 1's that can be decoded both as 11 and 111 */
		if (section[section_nr].temp_value==3) {
			global_value+=2;	
			check (section_nr+1, zeros_res);
			global_value-=2;
		}
		/* all cases of distributing zeros_res in the sections following were checked, so the function returns to the preceding section */
		section[section_nr].temp_value=section[section_nr].value;
		return;
		} else {
		/* the final section */
			if ((zeros_res>section[section_nr].zeros)||((section[section_nr].temp_value==1)&&(zeros_res==1))) {section[section_nr].temp_value=section[section_nr].value; return;}
			if (global_value + section[section_nr].temp_value * Math.pow (2, zeros_res) == N) result++; // a solution is found
			if ((zeros_res==0)&&(section[section_nr].temp_value==3)&&(global_value + 2==N)) result++; // a special case - the final section is in the form 11[00..0] and none of its 0's are used, so it can be decoded as 11 or as 111
			section[section_nr].temp_value = section[section_nr].value;
			return;
		}
	}

	static public void main(String[] args) throws IOException {
		BufferedReader bufReader = new BufferedReader(new InputStreamReader(System.in));
		int length;
		int zeros;
		int i;
		String code;
		StringTokenizer st = new StringTokenizer(bufReader.readLine()); 
		L=Integer.parseInt(st.nextToken());
		N=Integer.parseInt(st.nextToken());
		casenumber=0;
		while((L!=0)||(N!=0)){
			length=0;
			zeros=0;
			sections=0;
			global_value=0;
			result=0;
			casenumber++;
			for (i=0; i<40; i++) section[i]=new Interval();
			st = new StringTokenizer(bufReader.readLine());
			code=st.nextToken();
			length=code.length();
			i=0;
			while((i<length)&&(code.charAt(i)=='0')) { zeros++; i++; }
			while(i<length){
				while ((i<length)&&(code.charAt(i)=='1')) { section[sections].value=section[sections].value*2+1; i++; }
				while ((i<length)&&(code.charAt(i)=='0')) { section[sections].zeros++; zeros++; i++; }
				sections++;
			}
			for(i=0;i<sections;i++) section[i].temp_value=section[i].value;

			if((zeros-L+N<0)||(L<N)) result=0; else check(0, zeros - L + N);
	
			switch (result) {
				case 0: System.out.println("Case #"+casenumber+": NO"); break;
				case 1: System.out.println("Case #"+casenumber+": YES"); break;
				default: System.out.println("Case #"+casenumber+": NOT UNIQUE"); break;
			}
			st = new StringTokenizer(bufReader.readLine()); 
			L=Integer.parseInt(st.nextToken());
			N=Integer.parseInt(st.nextToken());
		}
	}
}
